<#--
 # MCreator (https://mcreator.net/)
 # Copyright (C) 2020 Pylo and contributors
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 # 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <https://www.gnu.org/licenses/>.
 # 
 # Additional permission for code generator templates (*.ftl files)
 # 
 # As a special exception, you may create a larger work that contains part or 
 # all of the MCreator code generator templates (*.ftl files) and distribute 
 # that work under terms of your choice, so long as that work isn't itself a 
 # template for code generation. Alternatively, if you modify or redistribute 
 # the template itself, you may (at your option) remove this special exception, 
 # which will cause the template and the resulting code generator output files 
 # to be licensed under the GNU General Public License without this special 
 # exception.
-->

<#-- @formatter:off -->
<#include "boundingboxes.java.ftl">
<#include "procedures.java.ftl">
<#include "mcitems.ftl">

package ${package}.block;

import net.minecraft.util.SoundEvent;

@${JavaModName}Elements.ModElement.Tag public class ${name}Block extends ${JavaModName}Elements.ModElement {

	@ObjectHolder("${modid}:${registryname}")
	public static final Block block = null;

	<#if data.hasTileEntity>
	@ObjectHolder("${modid}:${registryname}")
	public static final TileEntityType<CustomTileEntity> tileEntityType = null;
	</#if>

	public ${name}Block(${JavaModName}Elements instance) {
		super(instance, ${data.getModElement().getSortID()});

		<#if data.hasTileEntity || data.tintType != "No tint">
		FMLJavaModLoadingContext.get().getModEventBus().register(this);
		</#if>
	}

	@Override public void initElements() {
		elements.blocks.add(() -> new BlockCustomFlower());
		elements.items.add(() -> new <#if data.plantType == "double">Tall</#if>BlockItem(block, new Item.Properties().group(${data.creativeTab})).setRegistryName(block.getRegistryName()));
	}

	<#if data.hasTileEntity>
	@SubscribeEvent public void registerTileEntity(RegistryEvent.Register<TileEntityType<?>> event) {
		event.getRegistry().register(TileEntityType.Builder.create(CustomTileEntity::new, block).build(null).setRegistryName("${registryname}"));
	}
	</#if>

	@OnlyIn(Dist.CLIENT) public BlockRenderLayer getRenderLayer() {
		return BlockRenderLayer.CUTOUT;
	}

	<#if data.tintType != "No tint">
	@OnlyIn(Dist.CLIENT) @SubscribeEvent public void blockColorLoad(ColorHandlerEvent.Block event) {
		event.getBlockColors().register((bs, world, pos, index) -> {
			return world != null && pos != null ?
			<#if data.tintType == "Grass">
				BiomeColors.getGrassColor(world, pos) : GrassColors.get(0.5D, 1.0D);
			<#elseif data.tintType == "Foliage">
				BiomeColors.getFoliageColor(world, pos) : FoliageColors.getDefault();
			<#elseif data.tintType == "Water">
				BiomeColors.getWaterColor(world, pos) : -1;
			<#else>
				Minecraft.getInstance().world.getBiome(pos).getWaterFogColor() : 329011;
			</#if>
		}, block);
	}

		<#if data.isItemTinted>
		@OnlyIn(Dist.CLIENT) @SubscribeEvent public void itemColorLoad(ColorHandlerEvent.Item event) {
			event.getItemColors().register((stack, index) -> {
				<#if data.tintType == "Grass">
					return GrassColors.get(0.5D, 1.0D);
				<#elseif data.tintType == "Foliage">
					return FoliageColors.getDefault();
				<#elseif data.tintType == "Water">
					return 3694022;
				<#else>
					return 329011;
				</#if>
			}, block);
		}
		</#if>
	</#if>

	<#if (data.spawnWorldTypes?size > 0)>
	@Override public void init(FMLCommonSetupEvent event) {
		<#if data.plantType == "normal">
			<#if data.staticPlantGenerationType == "Flower">
			FlowersFeature feature = new FlowersFeature(NoFeatureConfig::deserialize) {
				@Override public BlockState getRandomFlower(Random random, BlockPos pos) {
      				return block.getDefaultState();
   				}
			<#else>
			GrassFeature feature = new GrassFeature(GrassFeatureConfig::deserialize) {
			</#if>

				@Override public boolean place(IWorld world, ChunkGenerator generator, Random random, BlockPos pos,
						<#if data.staticPlantGenerationType == "Flower">
						NoFeatureConfig config
						<#else>
						GrassFeatureConfig config
						</#if>
				) {
					DimensionType dimensionType = world.getDimension().getType();
					boolean dimensionCriteria = false;

    				<#list data.spawnWorldTypes as worldType>
						<#if worldType=="Surface">
							if(dimensionType == DimensionType.OVERWORLD)
								dimensionCriteria = true;
						<#elseif worldType=="Nether">
							if(dimensionType == DimensionType.THE_NETHER)
								dimensionCriteria = true;
						<#elseif worldType=="End">
							if(dimensionType == DimensionType.THE_END)
								dimensionCriteria = true;
						<#else>
							if(dimensionType == ${(worldType.toString().replace("CUSTOM:", ""))}Dimension.type)
								dimensionCriteria = true;
						</#if>
					</#list>

					if(!dimensionCriteria)
						return false;

					<#if hasProcedure(data.generateCondition)>
					int x = pos.getX();
					int y = pos.getY();
					int z = pos.getZ();
					if (!<@procedureOBJToConditionCode data.generateCondition/>)
						return false;
					</#if>

					return super.place(world, generator, random, pos, config);
				}
			};
		<#elseif data.plantType == "growapable">
			Feature<NoFeatureConfig> feature = new Feature<NoFeatureConfig>(NoFeatureConfig::deserialize) {
				@Override public boolean place(IWorld world, ChunkGenerator generator, Random random, BlockPos pos, NoFeatureConfig config) {
					DimensionType dimensionType = world.getDimension().getType();
					boolean dimensionCriteria = false;

    				<#list data.spawnWorldTypes as worldType>
						<#if worldType=="Surface">
							if(dimensionType == DimensionType.OVERWORLD)
								dimensionCriteria = true;
						<#elseif worldType=="Nether">
							if(dimensionType == DimensionType.THE_NETHER)
								dimensionCriteria = true;
						<#elseif worldType=="End">
							if(dimensionType == DimensionType.THE_END)
								dimensionCriteria = true;
						<#else>
							if(dimensionType == ${(worldType.toString().replace("CUSTOM:", ""))}Dimension.type)
								dimensionCriteria = true;
						</#if>
					</#list>

					if(!dimensionCriteria)
						return false;

					<#if hasProcedure(data.generateCondition)>
					int x = pos.getX();
					int y = pos.getY();
					int z = pos.getZ();
					if (!<@procedureOBJToConditionCode data.generateCondition/>)
						return false;
					</#if>

					int generated = 0;
      				for(int j = 0; j < ${data.frequencyOnChunks}; ++j) {
						BlockPos blockpos = pos.add(random.nextInt(4) - random.nextInt(4), 0, random.nextInt(4) - random.nextInt(4));
						if (world.isAirBlock(blockpos)) {
							BlockPos blockpos1 = blockpos.down();
							int k = 1 + random.nextInt(random.nextInt(${data.growapableMaxHeight}) + 1);
							k = Math.min(${data.growapableMaxHeight}, k);
							for(int l = 0; l < k; ++l) {
								if (block.getDefaultState().isValidPosition(world, blockpos)) {
									world.setBlockState(blockpos.up(l), block.getDefaultState(), 2);
									generated++;
								}
							}
						}
      				}
      				return generated > 0;
				}
			};
		<#elseif data.plantType == "double">
		    <#if data.doublePlantGenerationType == "Flower"> DoublePlantFeature feature = new DoublePlantFeature(DoublePlantConfig::deserialize)
		    <#else> Feature<NoFeatureConfig> feature = new Feature<NoFeatureConfig>(NoFeatureConfig::deserialize) </#if> {
		        @Override public boolean place(IWorld world, ChunkGenerator generator, Random random, BlockPos pos,
		        <#if data.doublePlantGenerationType == "Flower">DoublePlant<#else>NoFeature</#if>Config config) {
                		DimensionType dimensionType = world.getDimension().getType();
                		boolean dimensionCriteria = false;

                    	<#list data.spawnWorldTypes as worldType>
            	    	<#if worldType=="Surface">
            		        if(dimensionType == DimensionType.OVERWORLD)
            				dimensionCriteria = true;
            	    	<#elseif worldType=="Nether">
            		        if(dimensionType == DimensionType.THE_NETHER)
            				dimensionCriteria = true;
            	    	<#elseif worldType=="End">
            		        if(dimensionType == DimensionType.THE_END)
            				dimensionCriteria = true;
            	    	<#else>
            		        if(dimensionType == ${(worldType.toString().replace("CUSTOM:", ""))}Dimension.type)
            				dimensionCriteria = true;
            	    	</#if>
            		</#list>

                		if(!dimensionCriteria)
                			return false;

                		<#if hasProcedure(data.generateCondition)>
                		    int x = pos.getX();
                		    int y = pos.getY();
                		    int z = pos.getZ();
                		    if (!<@procedureOBJToConditionCode data.generateCondition/>)
                		    	return false;
                		</#if>

                        <#if data.doublePlantGenerationType == "Flower">
                	    return super.place(world, generator, random, pos, config);
                	    <#else>
                	    for (BlockState blockstate = world.getBlockState(pos); (blockstate.isAir() || blockstate.isIn(BlockTags.LEAVES))
                        			&& pos.getY() > 0; blockstate = world.getBlockState(pos)) {
                        	pos = pos.down();
                        }
                        int i = 0;
                        for (int j = 0; j < 128; ++j) {
                        	BlockPos blockpos = pos.add(random.nextInt(8) - random.nextInt(8), random.nextInt(4) - random.nextInt(4),
                        			random.nextInt(8) - random.nextInt(8));
                        	if (world.isAirBlock(blockpos) && block.getDefaultState().isValidPosition(world, blockpos)) {
                        		((DoublePlantBlock) block).placeAt(world, blockpos, 2);
                        		++i;
                        	}
                        }
                        return i > 0;
                	    </#if>
                    }
                };
		</#if>

		for (Biome biome : ForgeRegistries.BIOMES.getValues()) {
			<#if data.restrictionBiomes?has_content>
				boolean biomeCriteria = false;
				<#list data.restrictionBiomes as restrictionBiome>
					<#if restrictionBiome.canProperlyMap()>
					if (ForgeRegistries.BIOMES.getKey(biome).equals(new ResourceLocation("${restrictionBiome}")))
						biomeCriteria = true;
					</#if>
				</#list>
				if (!biomeCriteria)
					continue;
			</#if>

			<#if (data.plantType == "normal" && data.staticPlantGenerationType == "Grass") || (data.plantType == "double" && data.doublePlantGenerationType == "Grass")>
			biome.addFeature(GenerationStage.Decoration.VEGETAL_DECORATION, Biome.createDecoratedFeature(feature,
			    new <#if data.plantType == "normal">GrassFeatureConfig(block.getDefaultState())<#else>NoFeatureConfig()</#if>,
					Placement.NOISE_HEIGHTMAP_32, new NoiseDependant(-0.8, 0, ${data.frequencyOnChunks})
			));
			<#else>
			biome.addFeature(GenerationStage.Decoration.VEGETAL_DECORATION, Biome.createDecoratedFeature(feature,
			<#if data.plantType == "double">new DoublePlantConfig(block.getDefaultState())<#else>IFeatureConfig.NO_FEATURE_CONFIG</#if>,
					Placement.<#if data.plantType == "normal" || data.plantType == "double">COUNT_HEIGHTMAP_32<#else>COUNT_HEIGHTMAP_DOUBLE</#if>, new FrequencyConfig(${data.frequencyOnChunks})
			));
			</#if>
		}
	}
	</#if>

	public static class BlockCustomFlower extends <#if data.plantType == "normal">Flower<#elseif data.plantType == "growapable">SugarCane<#elseif data.plantType == "double">DoublePlant</#if>Block {

		public BlockCustomFlower() {
			super(<#if data.plantType == "normal">
				${data.suspiciousStewEffect?starts_with("CUSTOM:")?then("Effects.SATURATION", generator.map(data.suspiciousStewEffect, "effects"))}, ${data.suspiciousStewDuration},</#if>
					<#if generator.map(data.colorOnMap, "mapcolors") != "DEFAULT">
					Block.Properties.create(Material.PLANTS, MaterialColor.${generator.map(data.colorOnMap, "mapcolors")})
					<#else>
					Block.Properties.create(Material.PLANTS)
					</#if>
					<#if data.plantType == "growapable" || data.forceTicking>
					.tickRandomly()
					</#if>
					.doesNotBlockMovement()
					<#if data.isCustomSoundType>
						.sound(new SoundType(1.0f, 1.0f, null, null, null, null, null){
							@Override public SoundEvent getBreakSound() { return new SoundEvent(new ResourceLocation("${data.breakSound}")); }
							@Override public SoundEvent getStepSound() { return new SoundEvent(new ResourceLocation("${data.stepSound}")); }
							@Override public SoundEvent getPlaceSound() { return new SoundEvent(new ResourceLocation("${data.placeSound}")); }
							@Override public SoundEvent getHitSound() { return new SoundEvent(new ResourceLocation("${data.hitSound}")); }
							@Override public SoundEvent getFallSound() { return new SoundEvent(new ResourceLocation("${data.fallSound}")); }
						})
					<#else>
						.sound(SoundType.${data.soundOnStep})
					</#if>
					<#if data.unbreakable>
					.hardnessAndResistance(-1, 3600000)
					<#else>
					.hardnessAndResistance(${data.hardness}f, ${data.resistance}f)
					</#if>
					.lightValue(${data.luminance})
			);
			setRegistryName("${registryname}");
		}

		<#if data.plantType == "normal">
			<#if data.suspiciousStewEffect?starts_with("CUSTOM:")>
			@Override public Effect getStewEffect() {
				return ${generator.map(data.suspiciousStewEffect, "effects")};
			}
			</#if>

			<#if (data.suspiciousStewDuration > 0)>
			@Override public int getStewEffectDuration() {
				return ${data.suspiciousStewDuration};
			}
			</#if>
		</#if>

		<#if data.customBoundingBox && data.boundingBoxes??>
		@Override public VoxelShape getShape(BlockState state, IBlockReader world, BlockPos pos, ISelectionContext context) {
			<#if data.isBoundingBoxEmpty()>
				return VoxelShapes.empty();
			<#else>
				<#if !data.disableOffset> Vec3d offset = state.getOffset(world, pos); </#if>
				<@makeBoundingBox data.positiveBoundingBoxes() data.negativeBoundingBoxes() data.disableOffset "north"/>
			</#if>
		}
		</#if>

        	<#if data.isReplaceable>
        @Override public boolean isReplaceable(BlockState state, BlockItemUseContext useContext) {
			return useContext.getItem().getItem() != this.asItem();
		}
        	</#if>

		<#if data.flammability != 0>
		@Override public int getFlammability(BlockState state, IBlockReader world, BlockPos pos, Direction face) {
			return ${data.flammability};
		}
		</#if>

		<#if generator.map(data.aiPathNodeType, "pathnodetypes") != "DEFAULT">
		@Override public PathNodeType getAiPathNodeType(BlockState state, IBlockReader world, BlockPos pos, MobEntity entity) {
			return PathNodeType.${generator.map(data.aiPathNodeType, "pathnodetypes")};
		}
		</#if>

		<#if data.offsetType != "XZ">
		@Override public Block.OffsetType getOffsetType() {
			return Block.OffsetType.${data.offsetType};
		}
		</#if>

		<#if data.emissiveRendering>
        @OnlyIn(Dist.CLIENT) @Override public int getPackedLightmapCoords(BlockState state, IEnviromentBlockReader worldIn, BlockPos pos) {
			return 15728880;
		}
		</#if>

		<#if data.specialInfo?has_content>
		@Override @OnlyIn(Dist.CLIENT) public void addInformation(ItemStack itemstack, IBlockReader world, List<ITextComponent> list, ITooltipFlag flag) {
			super.addInformation(itemstack, world, list, flag);
			<#list data.specialInfo as entry>
			list.add(new StringTextComponent("${JavaConventions.escapeStringForJava(entry)}"));
			</#list>
		}
		</#if>

		<#if data.fireSpreadSpeed != 0>
		@Override public int getFireSpreadSpeed(BlockState state, IBlockReader world, BlockPos pos, Direction face) {
			return ${data.fireSpreadSpeed};
		}
		</#if>

		<#if data.creativePickItem?? && !data.creativePickItem.isEmpty()>
		@Override public ItemStack getPickBlock(BlockState state, RayTraceResult target, IBlockReader world, BlockPos pos, PlayerEntity player) {
        	return ${mappedMCItemToItemStackCode(data.creativePickItem, 1)};
    		}
        	</#if>

        <#if !data.useLootTableForDrops>
		    <#if data.dropAmount != 1 && !(data.customDrop?? && !data.customDrop.isEmpty())>
		    @Override public List<ItemStack> getDrops(BlockState state, LootContext.Builder builder) {
                <#if data.plantType == "double">
                if(state.get(BlockStateProperties.DOUBLE_BLOCK_HALF) != DoubleBlockHalf.LOWER)
                    return Collections.emptyList();
                </#if>

                List<ItemStack> dropsOriginal = super.getDrops(state, builder);
			    if(!dropsOriginal.isEmpty())
				    return dropsOriginal;
			    return Collections.singletonList(new ItemStack(this, ${data.dropAmount}));
		    }
		    <#elseif data.customDrop?? && !data.customDrop.isEmpty()>
		    @Override public List<ItemStack> getDrops(BlockState state, LootContext.Builder builder) {
			    <#if data.plantType == "double">
                if(state.get(BlockStateProperties.DOUBLE_BLOCK_HALF) != DoubleBlockHalf.LOWER)
                    return Collections.emptyList();
                </#if>

                List<ItemStack> dropsOriginal = super.getDrops(state, builder);
			    if(!dropsOriginal.isEmpty())
				    return dropsOriginal;
			    return Collections.singletonList(${mappedMCItemToItemStackCode(data.customDrop, data.dropAmount)});
		    }
		    <#else>
		    @Override public List<ItemStack> getDrops(BlockState state, LootContext.Builder builder) {
                <#if data.plantType == "double">
                if(state.get(BlockStateProperties.DOUBLE_BLOCK_HALF) != DoubleBlockHalf.LOWER)
                    return Collections.emptyList();
                </#if>

                List<ItemStack> dropsOriginal = super.getDrops(state, builder);
			    if(!dropsOriginal.isEmpty())
				    return dropsOriginal;
			    return Collections.singletonList(new ItemStack(this, 1));
		    }
            </#if>
        </#if>

		<#if (data.canBePlacedOn?size > 0) || hasProcedure(data.placingCondition)>
			<#if data.plantType != "growapable">
			@Override public boolean isValidGround(BlockState state, IBlockReader worldIn, BlockPos pos) {
				<#if hasProcedure(data.placingCondition)>
				boolean additionalCondition = true;
				if (worldIn instanceof IWorld) {
					IWorld world = ((IWorld) worldIn;
					int x = pos.getX();
					int y = pos.getY() + 1;
					int z = pos.getZ();
					BlockState blockstate = world.getBlockState(pos.up());
					additionalCondition = <@procedureOBJToConditionCode data.placingCondition/>;
				}
				</#if>

				Block ground = state.getBlock();
				return
				<#if (data.canBePlacedOn?size > 0)>(
					<#list data.canBePlacedOn as canBePlacedOn>
						ground == ${mappedBlockToBlock(canBePlacedOn)}
						<#if canBePlacedOn?has_next>||</#if>
					</#list>)
				</#if>
				<#if (data.canBePlacedOn?size > 0) && hasProcedure(data.placingCondition)> && </#if>
				<#if hasProcedure(data.placingCondition)> additionalCondition </#if>;
			}
			</#if>

			@Override public boolean isValidPosition(BlockState blockstate, IWorldReader worldIn, BlockPos pos) {
				BlockPos blockpos = pos.down();
				BlockState groundState = worldIn.getBlockState(blockpos);
				Block ground = groundState.getBlock();

				<#if data.plantType = "normal">
					return this.isValidGround(groundState, worldIn, blockpos)
				<#elseif data.plantType == "growapable">
					<#if hasProcedure(data.placingCondition)>
					boolean additionalCondition = true;
					if (worldIn instanceof IWorld) {
						IWorld world = (IWorld) worldIn;
						int x = pos.getX();
						int y = pos.getY();
						int z = pos.getZ();
						additionalCondition = <@procedureOBJToConditionCode data.placingCondition/>;
					}
					</#if>

					return ground == this ||
					<#if (data.canBePlacedOn?size > 0)>(
						<#list data.canBePlacedOn as canBePlacedOn>
						ground == ${mappedBlockToBlock(canBePlacedOn)}
						<#if canBePlacedOn?has_next>||</#if>
					</#list>)</#if>
					<#if (data.canBePlacedOn?size > 0) && hasProcedure(data.placingCondition)> && </#if>
					<#if hasProcedure(data.placingCondition)> additionalCondition </#if>
				<#else>
					if (blockstate.get(HALF) == DoubleBlockHalf.UPPER)
						return ground == this && groundState.get(HALF) == DoubleBlockHalf.LOWER;
					else
						return this.isValidGround(groundState, worldIn, blockpos)
				</#if>;
			}
		</#if>

		@Override public PlantType getPlantType(IBlockReader world, BlockPos pos) {
			return PlantType.${generator.map(data.growapableSpawnType, "planttypes")};
		}

        <#if hasProcedure(data.onBlockAdded)>
		@Override public void onBlockAdded(BlockState blockstate, World world, BlockPos pos, BlockState oldState, boolean moving) {
			super.onBlockAdded(blockstate, world, pos, oldState, moving);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onBlockAdded/>
		}
        </#if>

        <#if hasProcedure(data.onTickUpdate) || data.plantType == "growapable">
		@Override public void tick(BlockState blockstate, World world, BlockPos pos, Random random) {
			<#if hasProcedure(data.onTickUpdate)>
			    int x = pos.getX();
			    int y = pos.getY();
			    int z = pos.getZ();
                <@procedureOBJToCode data.onTickUpdate/>
            </#if>

            <#if data.plantType == "growapable">
			if (!blockstate.isValidPosition(world, pos)) {
			   world.destroyBlock(pos, true);
			} else if (world.isAirBlock(pos.up())) {
			   int i = 1;
			   for(;world.getBlockState(pos.down(i)).getBlock() == this; ++i);
			   if (i < ${data.growapableMaxHeight}) {
			      int j = blockstate.get(AGE);
			      if (j == 15) {
			         world.setBlockState(pos.up(), getDefaultState());
			         world.setBlockState(pos, blockstate.with(AGE, 0), 4);
			      } else {
			         world.setBlockState(pos, blockstate.with(AGE, j + 1), 4);
			      }
			   }
			}
            </#if>
		}
        </#if>

        <#if hasProcedure(data.onRandomUpdateEvent)>
		@OnlyIn(Dist.CLIENT) @Override
		public void animateTick(BlockState blockstate, World world, BlockPos pos, Random random) {
			super.animateTick(blockstate, world, pos, random);
			PlayerEntity entity = Minecraft.getInstance().player;
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onRandomUpdateEvent/>
		}
        </#if>

        <#if hasProcedure(data.onNeighbourBlockChanges)>
		@Override
		public void neighborChanged(BlockState blockstate, World world, BlockPos pos, Block neighborBlock, BlockPos fromPos, boolean isMoving) {
			super.neighborChanged(blockstate, world, pos, neighborBlock, fromPos, isMoving);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onNeighbourBlockChanges/>
		}
        </#if>

        <#if hasProcedure(data.onEntityCollides)>
		@Override public void onEntityCollision(BlockState blockstate, World world, BlockPos pos, Entity entity) {
			super.onEntityCollision(blockstate, world, pos, entity);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onEntityCollides/>
		}
        </#if>

        <#if hasProcedure(data.onDestroyedByPlayer)>
		@Override
		public boolean removedByPlayer(BlockState blockstate, World world, BlockPos pos, PlayerEntity entity, boolean willHarvest, IFluidState fluid) {
			boolean retval = super.removedByPlayer(blockstate, world, pos, entity, willHarvest, fluid);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onDestroyedByPlayer/>
			return retval;
		}
        </#if>

        <#if hasProcedure(data.onDestroyedByExplosion)>
		@Override public void onExplosionDestroy(World world, BlockPos pos, Explosion e) {
			super.onExplosionDestroy(world, pos, e);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onDestroyedByExplosion/>
		}
        </#if>

        <#if hasProcedure(data.onStartToDestroy)>
		@Override public void onBlockClicked(BlockState blockstate, World world, BlockPos pos, PlayerEntity entity) {
			super.onBlockClicked(blockstate, world, pos, entity);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onStartToDestroy/>
		}
        </#if>

        <#if hasProcedure(data.onBlockPlacedBy)>
		@Override
		public void onBlockPlacedBy(World world, BlockPos pos, BlockState blockstate, LivingEntity entity, ItemStack itemstack) {
			super.onBlockPlacedBy(world, pos, blockstate, entity, itemstack);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			<@procedureOBJToCode data.onBlockPlacedBy/>
		}
        </#if>

        <#if hasProcedure(data.onRightClicked)>
		@Override public boolean onBlockActivated(BlockState blockstate, World world, BlockPos pos, PlayerEntity entity, Hand hand, BlockRayTraceResult hit) {
			boolean retval = super.onBlockActivated(blockstate, world, pos, entity, hand, hit);
			int x = pos.getX();
			int y = pos.getY();
			int z = pos.getZ();
			double hitX = hit.getHitVec().x;
			double hitY = hit.getHitVec().y;
			double hitZ = hit.getHitVec().z;
			Direction direction = hit.getFace();
			<#if hasReturnValueOf(data.onRightClicked, "actionresulttype")>
			return <@procedureOBJToActionResultTypeCode data.onRightClicked/>;
			<#else>
			<@procedureOBJToCode data.onRightClicked/>
			return true;
			</#if>
		}
        </#if>

		<#if data.hasTileEntity>
		@Override public boolean hasTileEntity(BlockState state) {
			return true;
		}

		@Override public TileEntity createTileEntity(BlockState state, IBlockReader world) {
			return new CustomTileEntity();
		}

		@Override
		public boolean eventReceived(BlockState state, World world, BlockPos pos, int eventID, int eventParam) {
			super.eventReceived(state, world, pos, eventID, eventParam);
			TileEntity tileentity = world.getTileEntity(pos);
			return tileentity == null ? false : tileentity.receiveClientEvent(eventID, eventParam);
		}
		</#if>

	}

	<#if data.hasTileEntity>
	private static class CustomTileEntity extends TileEntity {

		public CustomTileEntity() {
			super(tileEntityType);
		}

		@Override public SUpdateTileEntityPacket getUpdatePacket() {
			return new SUpdateTileEntityPacket(this.pos, 0, this.getUpdateTag());
		}

		@Override public CompoundNBT getUpdateTag() {
			return this.write(new CompoundNBT());
		}

		@Override public void onDataPacket(NetworkManager net, SUpdateTileEntityPacket pkt) {
			this.read(pkt.getNbtCompound());
		}

	}
	</#if>

}
<#-- @formatter:on -->
